(function($) {
    $.gamesRegistry('register', 'interaction', new (function() {

        var options = {
            'view_width': Infinity,
            'view_height': Infinity,
            'view_background_img': '',
        };

        this.createObj = function(data) {
            var obj = $('<div class="object"></div>');

            obj.css('background-image', 'url("' + preload.getResult(data.image).src + '")');

            area = new absoluteArea(data);
            area.applyAt(obj, {
                view_width: options.view_width,
                view_height: options.view_height
            });

            return obj;
        };

        this.makeDraggable = function(obj) {
            obj.draggable({
                containment: '#playground',
                start: function() {

                    $(this).addClass('drag-now');
                },
                stop: function() {
                    $(this).removeClass('drag-now')
                }
            });

        };

        this.makeRemovable = function(obj) {

            obj.click(function() {

                if ($('.task-content .remove').hasClass('on')) {

                    $(this).fadeOut('slow', function() {
                        $(this).remove();
                    });

                }

            });

        };

        this.init = function(data) {
            $.extend(options, data);
            // Set background

            console.log(preload);

            var background = preload.getResult(options.view_background_img).src;

            $('#playground').css('background-image', 'url("' + background + '")');

            var that = this;

            $.each(options.objects, function() {
                $('#playground').append(that.createObj(this));
            });

            var showRemove = false;

            // Create definded draggables
            $.each(options.draggables, function() {
                var obj = that.createObj(this);
                obj.addClass('drag-item');
                obj.css('background-repeat', 'no-repeat');
                obj.css('position', 'absolute');
                
                if (this.title !== undefined) {
                    obj.attr('title', this.title);
                }

                that.makeDraggable(obj);

                if (this.removable) {
                    that.makeRemovable(obj);

                    showRemove = true;
                }

                $('#playground').append(obj);
            });

            if (options.appendables !== undefined && options.appendables.length > 0) {

                //dodajemy możliwość dodawania				
                var leftOffset = 20;


                var obj1 = $('<div class="object tool-selected" style="display:none; height: 57%; width: 8%; top: 24%; position:absolute;cursor: pointer;background-size: contain; background-repeat: no-repeat; background-position:center;"></div>');
                obj1.css('background-image', 'url("' + preload.getResult('IMG_toolselected').src + '")');
                $('.task-content').append(obj1);


                $('#playground').click(function(ev) {

                    var s = $('.task-content .tool.selected');

                    console.log(s);

                    if (s.length == 0) {
                        return;
                    }

                    if ($('.task-content .remove').hasClass('on')) {
                        return;
                    }

                    console.log(ev);

                    var posX = ev.pageX - $(this).offset().left;
                    var posY = ev.pageY - $(this).offset().top;

                    var x = (posX / $('#playground').width()) * 100;
                    var y = (posY / $('#playground').height()) * 100;

                    console.log(x);

                    console.log(y);

                    var obj = $('<div class="object" style="background-repeat: no-repeat;"></div>');
                    obj.css('background-image', 'url("' + preload.getResult(s.data('image')).src + '")');

                    var width = 100 * s.data('width') / options.view_width;
                    var height = 100 * s.data('height') / options.view_height;

                    x = x - (width / 2);
                    y = y - (height / 2);

                    obj.width(width + '%');
                    obj.height(height + '%');

                    obj.css({
                        left: x + '%',
                        top: y + '%'
                    });

                    $('#playground').append(obj);

                    that.makeDraggable(obj);

                    if (s.data('removable')) {
                        that.makeRemovable(obj);
                    }
                });


                $.each(options.appendables, function() {

                    var data = this;

                    var obj = $('<div class="object tool" style="height:57%;width:8%;top:24%;position:absolute;cursor: pointer;background-size: contain; background-repeat: no-repeat; background-position:center;"></div>');
                    obj.css('background-image', 'url("' + preload.getResult(data.image).src + '")');


                    leftOffset += 9;
                    obj.css('left', leftOffset + '%');

                    obj.data('image', data.image);
                    obj.data('height', data.height);
                    obj.data('width', data.width);

                    if (data.removable) {
                        obj.data('removable', 1);

                        showRemove = true;

                    } else {
                        obj.data('removable', 0);
                    }

                    $('.task-content').append(obj);

                    obj.click(function() {
                        var $t = $(this);

                        if ($t.hasClass('selected')) {
                            $('.task-content .tool-selected').hide();
                            $t.removeClass('selected');
                        } else {
                            $('.task-content .tool-selected').css('left', $t.css('left'));
                            $('.task-content .tool-selected').show();

                            $('.task-content .tool').removeClass('selected');
                            $t.addClass('selected');

                            $('.task-content .remove').removeClass('on');
                        }

                    });

                });


                if (showRemove) {

                    $('.task-content .remove').show();

                    $('.task-content .remove').click(function() {
                        $(this).toggleClass('on');
                        $('.task-content .tool-selected').hide();
                        $('.task-content .tool').removeClass('selected');

                    });

                }


            }





        }
    })());
})(jQuery);

